# This is a .spec file for creating Redhat Linux 5.2 .rpm and .srpm files for 
# the wipl program package.

Summary: Make statistics on basis of packets seen on a LAN.
Name: wipl
%define version 990221
Version: %{version}
Release: 1
Copyright: GNU
Group: Applications/Networking
Source: ftp://sunsite.unc.edu/pub/Linux/system/network/monitor/wipl-%{version}.src.tar.gz
BuildRoot: /var/tmp/wiplroot

%description
The wipl program package is able to make statistics about
which network cards transfer how much on a LAN segment or
through certain routers or servers.

The program package contains a daemon program which collects
the information. For each packet seen on the LAN the daemon
executes a small user defined program makeing it possible to
make almost any kind of statistics.

Severel client programs are available to retreview the
information collected by the daemon. One of them is able to
write html files to easy publication from web pages.

%prep
%setup

%build
make CXXFLAGS="$RPM_OPT_FLAGS" 

%install
mkdir -p $RPM_BUILD_ROOT
make INSTALLDIR=$RPM_BUILD_ROOT/usr install
install -d -o 0 -g 0 $RPM_BUILD_ROOT/etc/rc.d/init.d $RPM_BUILD_ROOT/etc/logrotate.d
install -o 0 -g 0 redhat/wipld $RPM_BUILD_ROOT/etc/rc.d/init.d/wipld
install -m 644 -o 0 -g 0 redhat/logrotate $RPM_BUILD_ROOT/etc/logrotate.d/wipld
install -m 644 -o 0 -g 0 support/wipld.conf.default $RPM_BUILD_ROOT/etc/wipld.conf

%files
/usr/sbin/wipld
/usr/sbin/wiplcInetd
/usr/bin/wiplc
/usr/bin/wiplcExec
/etc/rc.d/init.d/wipld
/etc/logrotate.d/wipld
/usr/man/man1/wipl.1
/usr/man/man1/wiplc.1
/usr/man/man1/wiplcExec.1
/usr/man/man5/wipllang.5
/usr/man/man8/wipld.8
/usr/man/man8/wiplcInetd.8
%config /etc/wipld.conf
%doc wipl.lsm
%doc HISTORY
%doc LICENSE
%doc LICENSE.2
%doc support
%doc wiplJava

%post 
chkconfig --add wipld

%preun
if [ -e /var/run/wipld.pid ]; then
  /etc/rc.d/init.d/wipld stop
fi
  
%postun
chkconfig --del wipld
rm -f /var/log/wipld.*
